package sequoia.tags;

import sequoia.PeonFactory;
import sequoia.Peon;

import java.sql.ResultSet;
import java.sql.SQLException;

import javax.servlet.jsp.JspException;

import org.apache.log4j.Logger;

public class AffectedRowsCountTag extends javax.servlet.jsp.tagext.TagSupport {
  static Logger logger = Logger.getLogger(AffectedRowsCountTag.class);

  public int doStartTag() throws JspException {
    try {
      boolean result;
      String badQueryMsg = ((String)pageContext.getAttribute("badquery"));
      if (badQueryMsg != null) {
        return SKIP_BODY;
      }

      try {
        result = ((Boolean)pageContext.getAttribute("resultType")).booleanValue();
      } catch (Exception e) {
        throw new JspException("ResultType not set - probably using before 'query' element");
      }
      Peon peon = ((Peon)pageContext.getAttribute("peon"));
      int affectedRows = 0;
      if(result) {
        ResultSet resultSet = (ResultSet)pageContext.getAttribute("resultSet");
        if(resultSet == null) {
          throw new JspException("AffectedRows>doStart> Unable to retrieve ResultSet.");
        }
        affectedRows = getRowCount(resultSet);
      } else {
        affectedRows = peon.getLastUpdateCount();
      }
      pageContext.getOut().println(affectedRows);
    } catch (Exception e) {
      e.printStackTrace(System.err);
      throw new JspException(e.getMessage(), e);
    }

    return EVAL_BODY_INCLUDE;
  }

  private int getRowCount(ResultSet rs) throws SQLException {
    boolean fallback = false;
    Peon peon = null;
    try {
      String query = ((String)pageContext.getAttribute("query"));
      peon = new PeonFactory("sequoia.PooledConnectionFactory").newPeon();
      peon.executeQuery(query);
      rs = peon.getLastResultSet();

      int rows = 0;
      while(rs.next()) {
        rows++;
      }
      return rows;
    } catch (SQLException e) {
      throw e;
    } finally {
      if (peon != null)
        peon.unsummon();
    }
  }
}