package sequoia.tags;

import sequoia.PeonFactory;
import sequoia.Peon;

import java.sql.ResultSet;
import java.sql.SQLException;

import javax.servlet.jsp.JspException;

import org.apache.log4j.Logger;

public class QueryTag extends javax.servlet.jsp.tagext.TagSupport {
  static Logger logger = Logger.getLogger(QueryTag.class);

  protected String query;

  public void setQuery(String query) {
    this.query = query;
  }

  public int doStartTag() throws JspException {
    try {
      logger.info("Executing query " + query);
      PeonFactory pf = new PeonFactory("sequoia.PooledConnectionFactory");
      Peon peon = pf.newPeon();

      boolean result = false;
      try {
        result = peon.executeQuery(query);
      } catch (SQLException e) {
        pageContext.setAttribute("badquery", e.getMessage());
        logger.info("Invalid query" + e.getMessage());
        throw e;
      }
      pageContext.setAttribute("query", query);
      pageContext.setAttribute("peon", peon);
      pageContext.setAttribute("resultType", new Boolean(result));
      if(result) {
        logger.debug("TRUE: Returning Set");
        ResultSet rs = peon.getLastResultSet();

        pageContext.setAttribute("resultSet", rs);
      } else {
        logger.debug("FALSE: NONReturning Set");
        pageContext.setAttribute("updateCount", new Integer(peon.getLastUpdateCount()));
      }
    } catch (Exception e) {
      throw new JspException(e);
    }
    return SKIP_BODY;
  }
}