package sequoia.tags;

import sequoia.PeonFactory;
import sequoia.Peon;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import java.io.Writer;

import org.apache.log4j.Logger;

public class RowHeadTag extends javax.servlet.jsp.tagext.BodyTagSupport {
  static Logger logger = Logger.getLogger(RowHeadTag.class);

  protected String cellSeparator = "";;

  public int doEndTag() throws JspException {
    logger.debug("RowHead End");
    try {
      boolean result = ((Boolean)pageContext.getAttribute("resultType")).booleanValue();

      JspWriter out = pageContext.getOut();
      if(result) {
        ResultSet rs = (ResultSet)pageContext.getAttribute("resultSet");
        if(rs == null) {
          throw new JspException("RowHead>doEnd> Unable to retrieve ResultSet.");
        } else {
          printAsHTMLTable(rs, out);
        }
      }
    } catch (Exception e) {
      e.printStackTrace(System.err);
      throw new JspException(e);
    }
    return EVAL_PAGE;
  }

  public void printAsHTMLTable(ResultSet rs, Writer out) throws SQLException, java.io.IOException {
    ResultSetMetaData rsmd = rs.getMetaData();
    for(int i = 1; i <= rsmd.getColumnCount()-1; i++) {
      out.write(rsmd.getColumnName(i) + cellSeparator);
    }
    out.write(rsmd.getColumnName(rsmd.getColumnCount()));
  }

  public void setCellSeparator(String separator) {
    logger.debug("Cell separator set:" + separator);
    this.cellSeparator = separator;
  }
}